package com.huimv.env.device.listener;

import cn.hutool.json.JSON;
import cn.hutool.json.JSONUtil;
import com.huimv.env.common.entity.vo.AllData;
import com.huimv.env.common.utils.Const;
import com.huimv.env.common.utils.MathUtil2;
import com.huimv.env.device.service.DataService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.rabbit.annotation.RabbitHandler;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Map;

@Component
@Slf4j
public class DeviceListener {

    @Autowired
    private DataService dataService;


    @RabbitListener(queues = Const.QUEUE_ENV_SHUI_HUIMV_DATA)
    @RabbitHandler
    public void processReceive(Map<String,String> rawMap)   {
//        System.out.println(">>>>>>>>>>>>>> 11 接收数据 RawMap>>" + rawMap.toString());
        try {
            String askText = rawMap.get("askText");
            AllData allData = JSONUtil.toBean(askText, AllData.class);
            String event = allData.getEvent();
            //时间戳
            String timestamp = allData.getTimestamp();
            //机器id 4823290F01000000 01016B13
            String nodeEui = allData.getContent().getCommonMessage().getNodeEui();

            if ("NODE_DATA_UP".equals(event)){
                //数据
                String payload = allData.getContent().getNodeUplinkPacket().getNode().getPayload();
                dataService.saveData(payload,timestamp,nodeEui);
            }

            System.out.println("数据开始--->"+allData.toString());
        }catch (Exception e){
            System.out.println("数据异常"+e);
        }
    }

}
